2 # install - install a program, script, or datafile
6 scriptversion
=2005-02-02.21
8 # This originates from X11R5 (mit/util/scripts/install.sh), which was
9 # later released in X11R6 (xc/config/util/install.sh) with the
10 # following copyright and license.
12 # Copyright (C) 1994 X Consortium
14 # Permission is hereby granted, free of charge, to any person obtaining a copy
15 # of this software and associated documentation files (the "Software"), to
16 # deal in the Software without restriction, including without limitation the
17 # rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
18 # sell copies of the Software, and to permit persons to whom the Software is
19 # furnished to do so, subject to the following conditions:
21 # The above copyright notice and this permission notice shall be included in
22 # all copies or substantial portions of the Software.
24 # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
25 # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
26 # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
27 # X CONSORTIUM BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
28 # AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNEC-
29 # TION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
31 # Except as contained in this notice, the name of the X Consortium shall not
32 # be used in advertising or otherwise to promote the sale, use or other deal-
33 # ings in this Software without prior written authorization from the X Consor-
37 # FSF changes to this file are in the public domain.
39 # Calling this script install-sh is preferred over install.sh, to prevent
40 # `make' implicit rules from creating a file called install from it
41 # when there is no Makefile.
43 # This script is compatible with the BSD install script, but was written
44 # from scratch. It can only install one file at a time, a restriction
45 # shared with many OS's install programs.
47 # set DOITPROG to echo to test this script
49 # Don't use :- since 4.3BSD and earlier shells don't like it.
52 # put in absolute paths if you don't have them in your path; or use env. vars.
56 chmodprog
="${CHMODPROG-chmod}"
57 chownprog
="${CHOWNPROG-chown}"
58 chgrpprog
="${CHGRPPROG-chgrp}"
59 # Darwin normal strip removes symbols from shared libraries
60 # that are later needed for dynamic linking, so use strip -x.
61 # http://archives.postgresql.org/pgsql-hackers/2007-10/msg01470.php
62 if test `expr "\`uname
-a\
`" : 'Darwin'` -ne 0
63 then stripprog
="${STRIPPROG-strip -x}"
64 else stripprog
="${STRIPPROG-strip}"
67 mkdirprog
="${MKDIRPROG-mkdir}"
69 chmodcmd
="$chmodprog 0755"
81 usage
="Usage: $0 [OPTION]... [-T] SRCFILE DSTFILE
82 or: $0 [OPTION]... SRCFILES... DIRECTORY
83 or: $0 [OPTION]... -t DIRECTORY SRCFILES...
84 or: $0 [OPTION]... -d DIRECTORIES...
86 In the 1st form, copy SRCFILE to DSTFILE.
87 In the 2nd and 3rd, copy all SRCFILES to DIRECTORY.
88 In the 4th, create DIRECTORIES.
92 -d create directories instead of installing files.
93 -g GROUP $chgrpprog installed files to GROUP.
94 -m MODE $chmodprog installed files to MODE.
95 -o USER $chownprog installed files to USER.
96 -s $stripprog installed files.
97 -t DIRECTORY install into DIRECTORY.
98 -T report an error if DSTFILE is a directory.
99 --help display this help and exit.
100 --version display version info and exit.
102 Environment variables override the default commands:
103 CHGRPPROG CHMODPROG CHOWNPROG CPPROG MKDIRPROG MVPROG RMPROG STRIPPROG
106 while test -n "$1"; do
115 -g) chgrpcmd
="$chgrpprog $2"
120 --help) echo "$usage"; exit $?
;;
122 -m) chmodcmd
="$chmodprog $2"
127 -o) chowncmd
="$chownprog $2"
132 -s) stripcmd
=$stripprog
141 -T) no_target_directory
=true
145 --version) echo "$0 $scriptversion"; exit $?
;;
147 *) # When -d is used, all remaining arguments are directories to create.
148 # When -t is used, the destination is already specified.
149 test -n "$dir_arg$dstarg" && break
150 # Otherwise, the last argument is the destination. Remove it from $@.
153 if test -n "$dstarg"; then
154 # $@ is not empty: it contains at least $arg.
155 set fnord
"$@" "$dstarg"
165 if test -z "$1"; then
166 if test -z "$dir_arg"; then
167 echo "$0: no input file specified." >&2
170 # It's OK to call `install-sh -d' without argument.
171 # This can happen when creating conditional directories.
177 # Protect names starting with `-'.
182 if test -n "$dir_arg"; then
186 if test -d "$dst"; then
193 # Waiting for this to be detected by the "$cpprog $src $dsttmp" command
194 # might cause directories to be created, which would be especially bad
195 # if $src (and thus $dsttmp) contains '*'.
196 if test ! -f "$src" && test ! -d "$src"; then
197 echo "$0: $src does not exist." >&2
201 if test -z "$dstarg"; then
202 echo "$0: no destination specified." >&2
207 # Protect names starting with `-'.
212 # If destination is a directory, append the input filename; won't work
213 # if double slashes aren't ignored.
214 if test -d "$dst"; then
215 if test -n "$no_target_directory"; then
216 echo "$0: $dstarg: Is a directory" >&2
219 dst
=$dst/`basename "$src"`
223 # This sed command emulates the dirname command.
224 dstdir
=`echo "$dst" | sed -e 's,/*$,,;s,[^/]*$,,;s,/*$,,;s,^$,.,'`
226 # Make sure that the destination directory exists.
228 # Skip lots of stat calls in the usual case.
229 if test ! -d "$dstdir"; then
232 IFS
="${IFS-$defaultIFS}"
235 # Some sh's can't handle IFS=/ for some reason.
237 set x
`echo "$dstdir" | sed -e 's@/@%@g' -e 's@^%@/@'`
243 while test $# -ne 0 ; do
246 if test ! -d "$pathcomp"; then
247 $mkdirprog "$pathcomp"
248 # mkdir can fail with a `File exist' error in case several
249 # install-sh are creating the directory concurrently. This
251 test -d "$pathcomp" ||
exit
257 if test -n "$dir_arg"; then
258 $doit $mkdircmd "$dst" \
259 && { test -z "$chowncmd" ||
$doit $chowncmd "$dst"; } \
260 && { test -z "$chgrpcmd" ||
$doit $chgrpcmd "$dst"; } \
261 && { test -z "$stripcmd" ||
$doit $stripcmd "$dst"; } \
262 && { test -z "$chmodcmd" ||
$doit $chmodcmd "$dst"; }
265 dstfile
=`basename "$dst"`
267 # Make a couple of temp file names in the proper directory.
268 dsttmp
=$dstdir/_inst.$
$_
269 rmtmp
=$dstdir/_rm.$
$_
271 # Trap to clean up those temp files at exit.
272 trap 'ret=$?; rm -f "$dsttmp" "$rmtmp" && exit $ret' 0
273 trap '(exit $?); exit' 1 2 13 15
275 # Copy the file name to the temp name.
276 $doit $cpprog "$src" "$dsttmp" &&
278 # and set any options; do chmod last to preserve setuid bits.
280 # If any of these fail, we abort the whole thing. If we want to
281 # ignore errors from any of these, just make sure not to ignore
282 # errors from the above "$doit $cpprog $src $dsttmp" command.
284 { test -z "$chowncmd" ||
$doit $chowncmd "$dsttmp"; } \
285 && { test -z "$chgrpcmd" ||
$doit $chgrpcmd "$dsttmp"; } \
286 && { test -z "$stripcmd" ||
$doit $stripcmd "$dsttmp"; } \
287 && { test -z "$chmodcmd" ||
$doit $chmodcmd "$dsttmp"; } &&
289 # Now rename the file to the real destination.
290 { $doit $mvcmd -f "$dsttmp" "$dstdir/$dstfile" 2>/dev
/null \
292 # The rename failed, perhaps because mv can't rename something else
293 # to itself, or perhaps because mv is so ancient that it does not
296 # Now remove or move aside any old file at destination location.
297 # We try this two ways since rm can't unlink itself on some
298 # systems and the destination file might be busy for other
299 # reasons. In this case, the final cleanup might fail but the new
300 # file should still install successfully.
302 if test -f "$dstdir/$dstfile"; then
303 $doit $rmcmd -f "$dstdir/$dstfile" 2>/dev
/null \
304 ||
$doit $mvcmd -f "$dstdir/$dstfile" "$rmtmp" 2>/dev
/null \
306 echo "$0: cannot unlink or rename $dstdir/$dstfile" >&2
314 # Now rename the file to the real destination.
315 $doit $mvcmd "$dsttmp" "$dstdir/$dstfile"
318 fi ||
{ (exit 1); exit 1; }
321 # The final little trick to "correctly" pass the exit status to the exit trap.
327 # eval: (add-hook 'write-file-hooks 'time-stamp)
328 # time-stamp-start: "scriptversion="
329 # time-stamp-format: "%:y-%02m-%02d.%02H"
330 # time-stamp-end: "$"